Ruby: pm_global_variable_write_node Struct Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Fields
pm_global_variable_write_node Struct Reference

GlobalVariableWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_t | name
| GlobalVariableWriteNode::name.
pm_location_t | name_loc
| GlobalVariableWriteNode::name_loc.
struct pm_node * | value
| GlobalVariableWriteNode::value.
pm_location_t | operator_loc
| GlobalVariableWriteNode::operator_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

GlobalVariableWriteNode.

Represents writing to a global variable.

    $foo = 1
    ^^^^^^^^

Type: PM_GLOBAL_VARIABLE_WRITE_NODE

Definition at line 4285 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_global_variable_write_node::base

The embedded base node.

Definition at line 4287 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_global_variable_write_node::name

GlobalVariableWriteNode::name.

The name of the global variable, which is a `$` followed by an identifier. Alternatively, it can be one of the special global variables designated by a symbol.

    $foo = :bar  # name `:$foo`

    $_Test = 123 # name `:$_Test`

Definition at line 4299 of file ast.h.

Referenced by pm_dump_json().

## ◆ name_loc

pm_location_t pm_global_variable_write_node::name_loc

GlobalVariableWriteNode::name_loc.

The location of the global variable's name.

    $foo = :bar
    ^^^^

Definition at line 4309 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_global_variable_write_node::operator_loc

GlobalVariableWriteNode::operator_loc.

The location of the `=` operator.

    $foo = :bar
         ^

Definition at line 4332 of file ast.h.

Referenced by pm_dump_json().

## ◆ value

struct pm_node* pm_global_variable_write_node::value

GlobalVariableWriteNode::value.

The value to write to the global variable. It can be any non-void expression.

    $foo = :bar
           ^^^^

    $-xyz = 123
            ^^^

Definition at line 4322 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h